From 69978597155d4cfb23551a32952ab858300ce5df Mon Sep 17 00:00:00 2001
From: Ludwig Krispenz <lkrispen@redhat.com>
Date: Tue, 5 Sep 2017 11:00:16 +0200
Subject: [PATCH] Ticket 49043 - make replication conflicts transparent to
 clients

Bug Description:
replication conflicts are created mostly because of failures in manually applying updates on different servers or client applications. But once they are created many clients, applications and users have problems to understand and handle them properly

Fix Description:
- keep conflicts but add objectclass ldapsubentry to make them invisible by default
- extend urp handling to handle all conflict casees and have a consistent database on all servers

https://pagure.io/389-ds-base/issue/49043

Reviewed by: Mark, Thierry, William
---
 Makefile.am                                      |    1 +
 ldap/schema/02common.ldif                        |    1 +
 ldap/servers/plugins/replication/repl5.h         |    2 +
 ldap/servers/plugins/replication/repl5_init.c    |   58 +-
 ldap/servers/plugins/replication/repl5_plugins.c |   70 +-
 ldap/servers/plugins/replication/repl5_ruv.c     |    4 +-
 ldap/servers/plugins/replication/urp.c           | 1193 +++++++++++++++++++---
 ldap/servers/plugins/replication/urp.h           |    6 +
 ldap/servers/plugins/replication/urp_glue.c      |    2 +-
 ldap/servers/plugins/replication/urp_tombstone.c |  205 ++++
 ldap/servers/plugins/retrocl/retrocl_po.c        |    3 +-
 ldap/servers/slapd/back-ldbm/ldbm_add.c          |  174 +++-
 ldap/servers/slapd/back-ldbm/ldbm_delete.c       |  184 ++--
 ldap/servers/slapd/back-ldbm/ldbm_modify.c       |   11 +-
 ldap/servers/slapd/back-ldbm/ldbm_modrdn.c       |   17 +-
 ldap/servers/slapd/libmakefile                   |    2 +-
 ldap/servers/slapd/pblock.c                      |   26 +
 ldap/servers/slapd/pblock_v3.h                   |    1 +
 ldap/servers/slapd/plugin.c                      |    5 +
 ldap/servers/slapd/plugin_mmr.c                  |   71 ++
 ldap/servers/slapd/proto-slap.h                  |    6 +
 ldap/servers/slapd/slap.h                        |   11 +-
 ldap/servers/slapd/slapi-plugin.h                |   13 +
 ldap/servers/slapd/slapi-private.h               |    2 +
 24 files changed, 1771 insertions(+), 297 deletions(-)
 create mode 100644 ldap/servers/slapd/plugin_mmr.c

diff --git a/Makefile.am b/Makefile.am
index 425c71d..d4caa8b 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -1200,6 +1200,7 @@ libslapd_la_SOURCES = ldap/servers/slapd/add.c \
 	ldap/servers/slapd/pblock.c \
 	ldap/servers/slapd/plugin.c \
 	ldap/servers/slapd/plugin_acl.c \
+	ldap/servers/slapd/plugin_mmr.c \
 	ldap/servers/slapd/plugin_internal_op.c \
 	ldap/servers/slapd/plugin_mr.c \
 	ldap/servers/slapd/plugin_role.c \
diff --git a/ldap/schema/02common.ldif b/ldap/schema/02common.ldif
index dda75e7..70d64c0 100644
--- a/ldap/schema/02common.ldif
+++ b/ldap/schema/02common.ldif
@@ -129,6 +129,7 @@ attributeTypes: ( 2.16.840.1.113730.3.1.3023 NAME 'nsViewFilter' DESC 'Netscape
 attributeTypes: ( 2.16.840.1.113730.3.1.2063 NAME 'nsEncryptionAlgorithm' DESC 'Netscape defined attribute type' SYNTAX 1.3.6.1.4.1.1466.115.121.1.15 SINGLE-VALUE X-ORIGIN 'Netscape Directory Server' )
 attributeTypes: ( 2.16.840.1.113730.3.1.2093 NAME 'nsslapd-changelogsuffix' DESC 'Netscape defined attribute type' SYNTAX 1.3.6.1.4.1.1466.115.121.1.12 X-ORIGIN 'Netscape' )
 attributeTypes: ( 2.16.840.1.113730.3.1.2094 NAME 'nsslapd-parent-suffix' DESC 'Netscape defined attribute type' SYNTAX 1.3.6.1.4.1.1466.115.121.1.12 X-ORIGIN 'Netscape' )
+attributeTypes: ( 2.16.840.1.113730.3.1.2401 NAME 'ConflictCSN' DESC 'Netscape defined attribute type' SYNTAX 1.3.6.1.4.1.1466.115.121.1.15 USAGE directoryOperation X-ORIGIN 'Netscape Directory Server' )
 #
 # objectclasses:
 #
diff --git a/ldap/servers/plugins/replication/repl5.h b/ldap/servers/plugins/replication/repl5.h
index 2711c89..3bd878d 100644
--- a/ldap/servers/plugins/replication/repl5.h
+++ b/ldap/servers/plugins/replication/repl5.h
@@ -205,6 +205,8 @@ int multimaster_preop_modrdn(Slapi_PBlock *pb);
 int multimaster_preop_search(Slapi_PBlock *pb);
 int multimaster_preop_compare(Slapi_PBlock *pb);
 int multimaster_ruv_search(Slapi_PBlock *pb);
+int multimaster_mmr_preop (Slapi_PBlock *pb, int flags);
+int multimaster_mmr_postop (Slapi_PBlock *pb, int flags);
 int multimaster_bepreop_add(Slapi_PBlock *pb);
 int multimaster_bepreop_delete(Slapi_PBlock *pb);
 int multimaster_bepreop_modify(Slapi_PBlock *pb);
diff --git a/ldap/servers/plugins/replication/repl5_init.c b/ldap/servers/plugins/replication/repl5_init.c
index 100fc23..5badd7c 100644
--- a/ldap/servers/plugins/replication/repl5_init.c
+++ b/ldap/servers/plugins/replication/repl5_init.c
@@ -109,6 +109,7 @@ static Slapi_PluginDesc multimasterpostopdesc = {"replication-multimaster-postop
 static Slapi_PluginDesc multimasterinternalpreopdesc = {"replication-multimaster-internalpreop", VENDOR, DS_PACKAGE_VERSION, "Multi-master replication internal pre-operation plugin"};
 static Slapi_PluginDesc multimasterinternalpostopdesc = {"replication-multimaster-internalpostop", VENDOR, DS_PACKAGE_VERSION, "Multimaster replication internal post-operation plugin"};
 static Slapi_PluginDesc multimasterbepreopdesc = {"replication-multimaster-bepreop", VENDOR, DS_PACKAGE_VERSION, "Multimaster replication bepre-operation plugin"};
+static Slapi_PluginDesc multimasterbemmrdesc = {"replication-multimaster-bepreop", VENDOR, DS_PACKAGE_VERSION, "Multimaster replication be plugin"};
 static Slapi_PluginDesc multimasterbepostopdesc = {"replication-multimaster-bepostop", VENDOR, DS_PACKAGE_VERSION, "Multimaster replication bepost-operation plugin"};
 static Slapi_PluginDesc multimasterbetxnpostopdesc = {"replication-multimaster-betxnpostop", VENDOR, DS_PACKAGE_VERSION, "Multimaster replication be transaction post-operation plugin"};
 static Slapi_PluginDesc multimasterextopdesc = {"replication-multimaster-extop", VENDOR, DS_PACKAGE_VERSION, "Multimaster replication extended-operation plugin"};
@@ -337,10 +338,6 @@ multimaster_bepreop_init(Slapi_PBlock *pb)
 
     if (slapi_pblock_set(pb, SLAPI_PLUGIN_VERSION, SLAPI_PLUGIN_VERSION_01) != 0 ||
         slapi_pblock_set(pb, SLAPI_PLUGIN_DESCRIPTION, (void *)&multimasterbepreopdesc) != 0 ||
-        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_PRE_ADD_FN, (void *)multimaster_bepreop_add) != 0 ||
-        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_PRE_DELETE_FN, (void *)multimaster_bepreop_delete) != 0 ||
-        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_PRE_MODIFY_FN, (void *)multimaster_bepreop_modify) != 0 ||
-        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_PRE_MODRDN_FN, (void *)multimaster_bepreop_modrdn) != 0 ||
         slapi_pblock_set(pb, SLAPI_PLUGIN_BE_PRE_CLOSE_FN, (void *)cl5Close) != 0 ||
         slapi_pblock_set(pb, SLAPI_PLUGIN_BE_PRE_BACKUP_FN, (void *)cl5WriteRUV) != 0) {
         slapi_log_err(SLAPI_LOG_PLUGIN, repl_plugin_name, "multimaster_bepreop_init - Failed\n");
@@ -350,6 +347,21 @@ multimaster_bepreop_init(Slapi_PBlock *pb)
     return rc;
 }
 
+int
+multimaster_mmr_init( Slapi_PBlock *pb )
+{
+    int rc= 0; /* OK */
+
+    if(slapi_pblock_set(pb, SLAPI_PLUGIN_VERSION, SLAPI_PLUGIN_VERSION_01 ) != 0 ||
+       slapi_pblock_set(pb, SLAPI_PLUGIN_DESCRIPTION, (void *)&multimasterbemmrdesc ) != 0 ||
+       slapi_pblock_set(pb, SLAPI_PLUGIN_MMR_BETXN_PREOP, (void *) multimaster_mmr_preop ) != 0 ||
+       slapi_pblock_set(pb, SLAPI_PLUGIN_MMR_BETXN_POSTOP, (void *) multimaster_mmr_postop ) != 0) {
+       slapi_log_err(SLAPI_LOG_PLUGIN, repl_plugin_name, "multimaster_mmr_init - Failed\n" );
+       rc= -1;
+}
+
+return rc;
+}
 /*
  * betxnpreop: if betxn is on, call preop urp at betxnpreop.
  */
@@ -415,27 +427,35 @@ multimaster_betxnpostop_init(Slapi_PBlock *pb)
     void *mdn_fn;
 
     if (repl5_is_betxn) {
-        add_fn = multimaster_be_betxnpostop_add;
+        /* add_fn = multimaster_be_betxnpostop_add;
         del_fn = multimaster_be_betxnpostop_delete;
         mod_fn = multimaster_be_betxnpostop_modify;
         mdn_fn = multimaster_be_betxnpostop_modrdn;
+        */
+        if (slapi_pblock_set(pb, SLAPI_PLUGIN_VERSION, SLAPI_PLUGIN_VERSION_01) ||
+            slapi_pblock_set(pb, SLAPI_PLUGIN_DESCRIPTION,
+                             (void *)&multimasterbetxnpostopdesc)) {
+            slapi_log_err(SLAPI_LOG_PLUGIN, repl_plugin_name,
+                          "multimaster_betxnpostop_init - Failed\n");
+            rc = -1;
+        }
     } else {
         add_fn = multimaster_betxnpostop_add;
         del_fn = multimaster_betxnpostop_delete;
         mod_fn = multimaster_betxnpostop_modify;
         mdn_fn = multimaster_betxnpostop_modrdn;
-    }
 
-    if (slapi_pblock_set(pb, SLAPI_PLUGIN_VERSION, SLAPI_PLUGIN_VERSION_01) ||
-        slapi_pblock_set(pb, SLAPI_PLUGIN_DESCRIPTION,
-                         (void *)&multimasterbetxnpostopdesc) ||
-        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_TXN_POST_ADD_FN, add_fn) ||
-        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_TXN_POST_DELETE_FN, del_fn) ||
-        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_TXN_POST_MODRDN_FN, mdn_fn) ||
-        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_TXN_POST_MODIFY_FN, mod_fn)) {
-        slapi_log_err(SLAPI_LOG_PLUGIN, repl_plugin_name,
-                      "multimaster_betxnpostop_init - Failed\n");
-        rc = -1;
+        if (slapi_pblock_set(pb, SLAPI_PLUGIN_VERSION, SLAPI_PLUGIN_VERSION_01) ||
+            slapi_pblock_set(pb, SLAPI_PLUGIN_DESCRIPTION,
+                             (void *)&multimasterbetxnpostopdesc) ||
+            slapi_pblock_set(pb, SLAPI_PLUGIN_BE_TXN_POST_ADD_FN, add_fn) ||
+            slapi_pblock_set(pb, SLAPI_PLUGIN_BE_TXN_POST_DELETE_FN, del_fn) ||
+            slapi_pblock_set(pb, SLAPI_PLUGIN_BE_TXN_POST_MODRDN_FN, mdn_fn) ||
+            slapi_pblock_set(pb, SLAPI_PLUGIN_BE_TXN_POST_MODIFY_FN, mod_fn)) {
+            slapi_log_err(SLAPI_LOG_PLUGIN, repl_plugin_name,
+                          "multimaster_betxnpostop_init - Failed\n");
+            rc = -1;
+        }
     }
 
     return rc;
@@ -887,6 +907,12 @@ replication_multimaster_plugin_init(Slapi_PBlock *pb)
                                    multimaster_preop_init,
                                    "Multimaster replication preoperation plugin",
                                    NULL, identity);
+        /* Register the main mmr backend plugins */
+        rc = slapi_register_plugin("mmr", 1 /* Enabled */,
+                                   "multimaster_mmr_init",
+                                   multimaster_mmr_init,
+                                   "Multimaster replication be operation plugin",
+                                   NULL, identity);
         /* bepreop: setting SLAPI_TXN_RUV_MODS_FN and cleanup old stateinfo
          * -- should be done before transaction */
         /* if betxn is off, urp is called at bepreop. */
diff --git a/ldap/servers/plugins/replication/repl5_plugins.c b/ldap/servers/plugins/replication/repl5_plugins.c
index 7c98734..0aee882 100644
--- a/ldap/servers/plugins/replication/repl5_plugins.c
+++ b/ldap/servers/plugins/replication/repl5_plugins.c
@@ -581,6 +581,54 @@ purge_entry_state_information(Slapi_PBlock *pb)
         object_release(repl_obj);
     }
 }
+int
+
+multimaster_mmr_preop (Slapi_PBlock *pb, int flags)
+{
+	int rc= SLAPI_PLUGIN_SUCCESS;
+
+	switch (flags)
+	{
+	case SLAPI_PLUGIN_BE_PRE_ADD_FN:
+		rc = multimaster_bepreop_add(pb);
+		break;
+	case SLAPI_PLUGIN_BE_PRE_MODIFY_FN:
+		rc = multimaster_bepreop_modify(pb);
+		break;
+	case SLAPI_PLUGIN_BE_PRE_MODRDN_FN:
+		rc = multimaster_bepreop_modrdn(pb);
+		break;
+	case SLAPI_PLUGIN_BE_PRE_DELETE_FN:
+		rc = multimaster_bepreop_delete(pb);
+		break;
+	}
+	return rc;
+}
+
+int
+multimaster_mmr_postop (Slapi_PBlock *pb, int flags)
+{
+	int rc= SLAPI_PLUGIN_SUCCESS;
+
+	switch (flags)
+	{
+	case SLAPI_PLUGIN_BE_TXN_POST_ADD_FN:
+		rc = multimaster_be_betxnpostop_add(pb);
+		break;
+	case SLAPI_PLUGIN_BE_TXN_POST_DELETE_FN:
+		rc = multimaster_be_betxnpostop_delete(pb);
+		break;
+	case SLAPI_PLUGIN_BE_TXN_POST_MODIFY_FN:
+		rc = multimaster_be_betxnpostop_modify(pb);
+		break;
+	case SLAPI_PLUGIN_BE_TXN_POST_MODRDN_FN:
+		rc = multimaster_be_betxnpostop_modrdn(pb);
+		break;
+	}
+	slapi_log_err(SLAPI_LOG_REPL, REPLICATION_SUBSYSTEM,
+                     "multimaster_mmr_postop - error %d for oparation %d.\n", rc, flags);
+	return rc;
+}
 
 /* pure bepreop's -- should be done before transaction starts */
 int
@@ -686,6 +734,18 @@ multimaster_bepreop_modrdn(Slapi_PBlock *pb)
 }
 
 int
+multimaster_bepostop_add(Slapi_PBlock *pb)
+{
+    Slapi_Operation *op;
+
+    slapi_pblock_get(pb, SLAPI_OPERATION, &op);
+    if ( ! operation_is_flag_set (op, OP_FLAG_REPL_FIXUP) ) {
+        urp_post_add_operation (pb);
+    }
+    return SLAPI_PLUGIN_SUCCESS;
+}
+
+int
 multimaster_bepostop_modrdn(Slapi_PBlock *pb)
 {
     Slapi_Operation *op;
@@ -793,6 +853,7 @@ multimaster_be_betxnpostop_add(Slapi_PBlock *pb)
     int rc = 0;
     /* original betxnpost */
     rc = write_changelog_and_ruv(pb);
+    rc |= multimaster_bepostop_add(pb);
     return rc;
 }
 
@@ -1003,16 +1064,23 @@ write_changelog_and_ruv(Slapi_PBlock *pb)
         if (op_params->operation_type != SLAPI_OPERATION_MODIFY ||
             op_params->p.p_modify.modify_mods != NULL) {
             void *txn = NULL;
+            char csn_str[CSN_STRSIZE];
             if (cl5_is_diskfull() && !cl5_diskspace_is_available()) {
                 slapi_log_err(SLAPI_LOG_CRIT, repl_plugin_name,
                               "write_changelog_and_ruv - Skipped due to DISKFULL\n");
                 goto common_return;
             }
             slapi_pblock_get(pb, SLAPI_TXN, &txn);
+            slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name,
+                          "write_changelog_and_ruv - Writing change for "
+                          "%s (uniqid: %s, optype: %lu) to changelog csn %s\n",
+                          REPL_GET_DN(&op_params->target_address),
+                          op_params->target_address.uniqueid,
+                          op_params->operation_type,
+                          csn_as_string(op_params->csn, PR_FALSE, csn_str));
             rc = cl5WriteOperationTxn(repl_name, repl_gen, op_params,
                                       !operation_is_flag_set(op, OP_FLAG_REPLICATED), txn);
             if (rc != CL5_SUCCESS) {
-                char csn_str[CSN_STRSIZE];
                 /* ONREPL - log error */
                 slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name,
                               "write_changelog_and_ruv - Can't add a change for "
diff --git a/ldap/servers/plugins/replication/repl5_ruv.c b/ldap/servers/plugins/replication/repl5_ruv.c
index ea351e8..40dc092 100644
--- a/ldap/servers/plugins/replication/repl5_ruv.c
+++ b/ldap/servers/plugins/replication/repl5_ruv.c
@@ -1510,7 +1510,7 @@ ruv_add_csn_inprogress(void *repl, RUV *ruv, const CSN *csn)
     if (ruv_covers_csn_internal(ruv, csn, PR_FALSE)) {
         if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
             slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name, "ruv_add_csn_inprogress - "
-                                                            "The csn %s has already be seen - ignoring\n",
+                          "The csn %s has already be seen (in ruv) - ignoring\n",
                           csn_as_string(csn, PR_FALSE, csn_str));
         }
         rc = RUV_COVERS_CSN;
@@ -1531,7 +1531,7 @@ ruv_add_csn_inprogress(void *repl, RUV *ruv, const CSN *csn)
     {
         if (slapi_is_loglevel_set(SLAPI_LOG_REPL)) {
             slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name, "ruv_add_csn_inprogress - "
-                                                            "The csn %s has already be seen - ignoring\n",
+                          "The csn %s has already be seen (in csnpl) - ignoring\n",
                           csn_as_string(csn, PR_FALSE, csn_str));
         }
         set_thread_primary_csn(NULL, NULL);
